=== debian/changelog ===
libpappsomspp (0.9.17-1) unstable; urgency=low

  * Fixes (hopefully) to tests that failed under some platforms. This entailed
    using some tolerance in the way double values are compared.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 29 Aug 2023 12:42:55 +0200

libpappsomspp (0.9.16-1) unstable; urgency=low

  * New upstream version trying to explore the test run failures observed on
    other platforms than amd64. Namely, the fact that Catch2-based tests are
    run using dh_test as a single test with no meaningful output to check why
    it fails.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 28 Aug 2023 10:15:05 +0200

libpappsomspp (0.9.15-1) unstable; urgency=low

  * Force new upstream to upload tar.gz.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 25 Aug 2023 12:29:38 +0200

libpappsomspp (0.9.14-1) unstable; urgency=low

  * WIP: allow the possibility to configure the loading process for Bruker
    timsTOF data files.

  * Packaging for Debian unstable.

  * Make tests build and run fine in d/rules. Required working on
    tests/CMakeLists.txt to change LD_LIBRARY_PATH to the catch2 based
    test binary.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 24 Aug 2023 14:27:24 +0200

libpappsomspp (0.9.14-1~bookworm+1) bookworm; urgency=medium

  * bug fix on new Peptide::addAaModificationOnAllAminoAcid function
  used for C13N15 labeling

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 24 Aug 2023 13:08:56 +0200

libpappsomspp (0.9.13-1) unstable; urgency=low

  * Fix missing cstdint include.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 21 Aug 2023 19:36:58 +0200

libpappsomspp (0.9.13-1~bookworm+1) bookworm; urgency=medium

  [ Olivier Langella ]
  * tests for C13N15 methods
  * implementation of distance between traces based on the similarity cosine method
  [ Filippo Rusconi ]
  * implementation of C13N15 internal controled vocabulary
  * WIP: redesigning API for much flexible msrun reader

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 19 Jul 2023 15:03:01 +0200

libpappsomspp (0.9.12-1) unstable; urgency=low

  * Nothing new, just keeping up with version numbering... See version
    0.9.10-1 for details.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 20 Jun 2023 15:55:08 +0200

libpappsomspp (0.9.11-1~bookworm+1) bookworm; urgency=medium

  * new bookworm package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 16 Jun 2023 17:48:45 +0200

libpappsomspp (0.9.10-1~bullseye+1) bullseye; urgency=medium

  * work on PSM features

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 04 May 2023 15:33:21 +0200

libpappsomspp (0.9.10-1) unstable; urgency=low

  * New upstream version fixing odd bug with fabs() required when a double
    value is negative (determination of the decimals required to display
    values in the traces upon measurement of inter-peak distances).
  * Indirectly fix the #include <cstdint> that was missing in libpwizlite and
    that made build failures with new g++-13 (Closes: #1037734).

  * libpwizlite-dev (>= 3.0.5) version dependency update.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 27 Apr 2023 17:13:46 +0200

libpappsomspp (0.9.9-1) unstable; urgency=medium

  * minX and maxX on trace

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 17 Mar 2023 16:25:31 +0100

libpappsomspp (0.9.7-1) bullseye; urgency=medium

  * Full Qt6 switch

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 17 Mar 2023 13:14:07 +0100
